// Includes the Servo library
#include "pitches.h"
#include <Servo.h>
#define LED_PIN_GREEN 4
#define LED_PIN_RED 7
#define BUTTON_PIN 8
#define BUZZER_PIN 3


// Defines Tirg and Echo pins of the Ultrasonic Sensor
const int trigPin = 10;
const int echoPin = 11;

// Variables for the duration and the distance
long duration;
int distance;
//byte systemState = LOW;
byte lastState;
byte ledState = HIGH; //trebuie high ca eu
unsigned long lastTimeButtonStateChanged = millis();
unsigned long debounceDuration = 50;
int thisNote = 0;
int notes = sizeof(melody) / sizeof(melody[0]) / 2;
// this calculates the duration of a whole note in ms (60s/tempo)*4 beats
int wholenote = (60000 * 4) / tempo;
int divider = 0, noteDuration = 0;

Servo myServo; // Creates a servo object for controlling the servo motor

void setup() {
  pinMode(trigPin, OUTPUT); // Sets the trigPin as an Output
  pinMode(echoPin, INPUT); // Sets the echoPin as an Input
  pinMode(LED_PIN_RED, OUTPUT);
  pinMode(LED_PIN_GREEN, OUTPUT);
  pinMode(BUTTON_PIN, INPUT);
  lastState = digitalRead(BUTTON_PIN);
  Serial.begin(9600);
  myServo.attach(12); // Defines on which pin is the servo motor attached
  digitalWrite(LED_PIN_RED, ledState);
  digitalWrite(LED_PIN_RED, !ledState);

  //pirates
  int notes = sizeof(melody) / sizeof(melody[0]) / 2;
  // this calculates the duration of a whole note in ms (60s/tempo)*4 beats
  int wholenote = (60000 * 4) / tempo;
  int divider = 0, noteDuration = 0;


}
void loop() {
  servo();
  //  int size = sizeof(noteDurations) / sizeof(int);
  //  for (int thisNote = 0; thisNote < size; thisNote++) {
  //
  //    // to calculate the note duration, take one second divided by the note type.
  //    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
  //    int noteDuration = 1000 / noteDurations[thisNote];
  //    tone(BUZZER_PIN, melody[thisNote], noteDuration);
  //
  //    // to distinguish the notes, set a minimum time between them.
  //    // the note's duration + 30% seems to work well:
  //    int pauseBetweenNotes = noteDuration * 1.30;
  //    delay(pauseBetweenNotes);
  //    // stop the tone playing:
  //    noTone(8);
  //  }

}
// Function for calculating the distance measured by the Ultrasonic sensor
int calculateDistance() {

  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  // Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin, HIGH); // Reads the echoPin, returns the sound wave travel time in microseconds
  distance = duration * 0.034 / 2;
  return distance;
}

void led() {
  if (millis() - lastTimeButtonStateChanged >= debounceDuration) {
    byte actualState = digitalRead(BUTTON_PIN);
    if (lastState != actualState) {
      lastTimeButtonStateChanged = millis();
      lastState = actualState; //for next loop
      if (actualState == LOW) { //released
        if (ledState == HIGH) {
          ledState = LOW;
        } else {
          ledState = HIGH;
        }
        digitalWrite(LED_PIN_RED, ledState);
        digitalWrite(LED_PIN_GREEN, !ledState);
      }
    }
  }
}

void button_interface() {
  if (Serial.available()) {
    char val = Serial.read();
    if (val == 'r') {
      ledState = LOW;
    }
    if (val == 'p') {
      ledState = HIGH;
    }
    if (val == 's' && ledState == LOW) {
      tone(BUZZER_PIN, 2000, 100); // Send 1KHz sound signal...
      delay(10);
      noTone(BUZZER_PIN);     // Stop sound...
    }
    digitalWrite(LED_PIN_RED, ledState);
    digitalWrite(LED_PIN_GREEN, !ledState);

    val = 'z';
  }
}
void servo() {
  // rotates the servo motor from 0 to 180 degrees
  for (int i = 0; i <= 180; i++) {
    led();
    button_interface();
    if (ledState == HIGH) {
      while (ledState == HIGH) {
        if (thisNote > notes * 2) {
          thisNote = 0;
        }
        led();
        button_interface();
        // calculates the duration of each note
        divider = melody[thisNote + 1];
        if (divider > 0) {
          // regular note, just proceed
          noteDuration = (wholenote) / divider;
        } else if (divider < 0) {
          // dotted notes are represented with negative durations!!
          noteDuration = (wholenote) / abs(divider);
          noteDuration *= 1.5; // increases the duration in half for dotted notes
        }

        // we only play the note for 90% of the duration, leaving 10% as a pause
        tone(BUZZER_PIN, melody[thisNote], noteDuration * 0.9);

        // Wait for the specief duration before playing the next note.
        delay(noteDuration);

        // stop the waveform generation before the next note.
        noTone(BUZZER_PIN);
        thisNote = thisNote + 2;
      }
    }
    myServo.write(i);
    delay(30);
    distance = calculateDistance();// Calls a function for calculating the distance measured by the Ultrasonic sensor for each degree

    Serial.print(i); // Sends the current degree into the Serial Port
    Serial.print(","); // Sends addition character right next to the previous value needed later in the Processing IDE for indexing
    Serial.print(distance); // Sends the distance value into the Serial Port
    Serial.print("."); // Sends addition character right next to the previous value needed later in the Processing IDE for indexing
  }
  // Repeats the previous lines from 180 to 0 degrees
  for (int i = 180; i > 0; i--) {
    led();
    button_interface();

    if (ledState == HIGH) {
      while (ledState == HIGH) {
        if (thisNote > notes * 2) {
          thisNote = 0;
        }
        led();
        button_interface();
        // calculates the duration of each note
        divider = melody[thisNote + 1];
        if (divider > 0) {
          // regular note, just proceed
          noteDuration = (wholenote) / divider;
        } else if (divider < 0) {
          // dotted notes are represented with negative durations!!
          noteDuration = (wholenote) / abs(divider);
          noteDuration *= 1.5; // increases the duration in half for dotted notes
        }

        // we only play the note for 90% of the duration, leaving 10% as a pause
        tone(BUZZER_PIN, melody[thisNote], noteDuration * 0.9);

        // Wait for the specief duration before playing the next note.
        delay(noteDuration);

        // stop the waveform generation before the next note.
        noTone(BUZZER_PIN);
        thisNote = thisNote + 2;
      }
    }
    myServo.write(i);
    delay(30);
    distance = calculateDistance();

    Serial.print(i);
    Serial.print(",");
    Serial.print(distance);
    Serial.print(".");
  }
}
